Index: less/less.nro
diff -u less/less.nro:1.1.1.11 less/less.nro:1.33
--- less/less.nro:1.1.1.11	Sun Dec  1 05:41:13 1996
+++ less/less.nro	Fri Jan 17 12:21:17 1997
@@ -10,7 +10,7 @@
 .br
 .B "less --version"
 .br
-.B "less [-[+]aBcCdeEfgGiImMnNqQrsSuUVwX]"
+.B "less [-[+]aBcCdeEfgGiImMnNqQrsSuUVwXZ]"
 .br
 .B "     [-b \fIbufs\fP] [-h \fIlines\fP] [-j \fIline\fP] [-k \fIkeyfile\fP]"
 .br
@@ -287,6 +287,13 @@
 If possible, it also prints the length of the file,
 the number of lines in the file
 and the percent of the file above the last displayed line.
+.IP "@"
+Rotate the code recognition method of the current file.
+Enhanced
+.I less
+has 7 methods for recognition, default (which is chosen
+by JLESSCHARSET environment variable), japanese, ujis, sjis,
+iso8, noconv and none.
 .IP \-
 Followed by one of the command line option letters (see below),
 this will change the setting of that option
@@ -698,6 +705,10 @@
 For example, if the screen is 24 lines, \fI-z-4\fP sets the 
 scrolling window to 20 lines.  If the screen is resized to 40 lines,
 the scrolling window automatically changes to 36 lines.
+.IP -Z
+Causes to give priority to the SJIS over the UJIS if japanese was selected
+as JLESSCHARSET environment variable.  The default is
+to give priority to the UJIS over the SJIS.
 .IP -"
 Changes the filename quoting character.
 This may be necessary if you are trying to name a file
@@ -971,8 +982,16 @@
 .PP
 A "character set" is simply a description of which characters are to
 be considered normal, control, and binary.
-The LESSCHARSET environment variable may be used to select a character set.
-Possible values for LESSCHARSET are:
+The JLESSCHARSET and LESSCHARSET environment variable may be used to select
+a character set.  There is no difference between them in program of
+.I less.
+But some value for it is allowed on only japanized
+.I less
+and it means you should use JLESSCHARSET
+if you want to use one of Japanese character sets.
+Because if you used LESSCHARSET and had used original less,
+it would make error about wrong LESSCHARSET value.
+Possible values for them are:
 .IP ascii
 The default character set.
 BS, TAB, NL, CR, and formfeed are control characters,
@@ -989,6 +1008,151 @@
 .IP next
 Selects a character set appropriate for NeXT computers.
 .PP
+And possible values for JLESSCHARSET are:
+.IP iso7
+Multi character sets with the ISO 2022 code extension techniques
+in 7 bits are assumed.
+Characters with values between 128 and 255 are treated as binary.
+The level of implementation of
+.I Less
+is level 3 of IOS 2022.
+.IP iso8
+Multi character sets with the ISO 2022 code extension techniques
+in 8 bits are assumed.
+The level of implementation of
+.I Less
+is level 3 of IOS 2022.
+.IP jis
+Only Japanese character sets with the ISO 2022 code extension
+techniques in 7 bits are assumed.
+.IP ujis
+If characters has values between 32 and 127,
+the ASCII character set are assumed.
+If characters has values between 162 and 254,
+the JISX 0208 character set,
+a right half of the JISX 0201 character set and
+the JISX 0212 character set with the UJIS coding are assumed.
+Otherwise, characters are treated as binary.
+.IP euc
+Same as ujis.
+.IP sjis
+If characters has values between 32 and 127,
+the ASCII character set are assumed.
+If characters has values between 128 and 252,
+the JISX 0208 character set and
+a right half of the JISX 0201 character set with the UJIS coding are assumed.
+Otherwise, characters are treated as binary.
+.IP japanese
+All Japanese character sets, jis, ujis and sjis, are assumed.  But
+.I less
+output only the jis.
+.PP
+Japanese has several code sets (not character sets).
+Thus
+.I less
+must convert among them to display it correctly.
+Possible values with this conversion for JLESSCHARSET are:
+.IP ujis-iso7
+The ujis and iso7 are assumend.  But
+.I less
+output only the iso7.
+.IP euc-iso7
+Same as ujis-iso7.
+.IP sjis-iso7
+The sjis and iso7 are assumend.  But
+.I less
+output only the iso7.
+.IP ujis-jis
+The ujis and jis are assumend.  But
+.I less
+output only the jis.
+.IP euc-jis
+Same as ujis-jis.
+.IP sjis-jis
+The sjis and jis are assumend.  But
+.I less
+output only the jis.
+.IP jis-ujis
+The jis and ujis are assumend.  But
+.I less
+output only the ujis.
+.IP jis-euc
+Same as jis-ujis.
+.IP jis-sjis
+The jis and sjis are assumend.  But
+.I less
+output only the sjis.
+.IP japanese-iso7
+The japanese and iso7 are assumend.  But
+.I less
+output only the iso7.
+.IP japanese-jis
+The japanese is assumend.  But
+.I less
+output only the jis.
+Same as japanese.
+.IP japanese-ujis
+The japanese is assumend.  But
+.I less
+output only the ujis.
+.IP japanese-euc
+Same as japanese-ujis.
+.IP japanese-sjis
+The japanese is assumend.  But
+.I less
+output only the sjis.
+.IP ujis-sjis
+The ujis is assumend.  But
+.I less
+output only the sjis.
+.IP euc-sjis
+Same as ujis-sjis.
+.IP sjis-ujis
+The sjis is assumend.  But
+.I less
+output only the ujis.
+.IP sjis-euc
+Same as sjis-ujis.
+.PP
+Other way to select a character set is to use the LANG environment variable.
+If it start with "ja_JP" or "japan",
+.I less
+read all Japanese coded characters as some Japanese character set,
+and a rest of the LANG environment variable specify output coding.
+.PP
+The ISO 2022 code extension techniques define
+4 planes for displaying many character sets easy.
+Default setting of planes is selected by
+the JLESSPLANESET environment variable.
+If the JLESSPLANESET vriable is equal to "japanese", "ujis" or "euc",
+.I less
+treat g1 plane as JISX 0208, g2 plane as JISX 0201 right half, g3 plane
+as JISX 0212.  If it is equal to "latin1", "latin2", "latin3", "latin4",
+"greek", "alabic", "hebrew", "cyrillic" or "latin5",
+.I less
+treat g1 plane as one of ISO 8859.
+Otherwise,
+.I less
+try to parse the JLESSPLANESET variable as 
+real escape sequence for setting up, and "\\e" in JLESSPLANESET
+is treated as escape code when parsing.
+.PP
+.I Less
+understand almost all escape sequence about character set
+in the ISO 2022 code extension techniques.  There are many escape sequences
+to select the character set.  On the one hand,
+.I less
+output only 6 escape sequences to select a character
+set: '^[(', '^[-', '^[$(', '^[$-', '^N' and '^O'.
+It means
+.I less
+is terminal friendly.
+.PP
+And there is special "character set" for keyboard inputs.
+The JLESSKEYCHARSET environment variable is used
+for such purpose.  Possible values of it are equal
+to the JLESSCHARSET environment variable.
+.PP
 In special cases, it may be desired to tailor
 .I less
 to use a character set other than the ones definable by LESSCHARSET.
@@ -1093,6 +1257,8 @@
 Usually used at the end of the string, but may appear anywhere.
 .IP "%x"
 Replaced by the name of the next input file in the list.
+.IP "%K"
+Replaced by the name of the last non ASCII character set or code set.
 .PP
 If any item is unknown (for example, the file size if input
 is a pipe), a question mark is printed instead.
@@ -1258,8 +1424,14 @@
 Format for displaying non-printable, non-control characters.
 .IP LESSCHARDEF
 Defines a character set.
-.IP LESSCHARSET
+.IP JLESSCHARSET
 Selects a predefined character set.
+.IP LESSCHARSET
+Selects a predefined character set if JLESSCHARSET is not defined.
+.IP JLESSKEYCHARSET
+Selects a predefined character set for keyboard inputs.
+.IP JLESSPLANESET
+Selects a predefined plane set of the ISO 2022 code extension techniques.
 .IP LESSCLOSE
 Command line to invoke the (optional) input-postprocessor.
 .IP LESSECHO
@@ -1335,4 +1507,8 @@
 Copyright (c) 1984,1985,1989,1994,1995,1996  Mark Nudelman
 .br
 Comments to: marknu@netcom.com
+.br
+Copyright (c) 1994,1995,1996,1997  Kazushi (Jam) Marukawa, Japanized routines only
+.br
+Comments to: jam@poboxes.com
 
Index: less/lesskey.c
diff -u less/lesskey.c:1.1.1.12 less/lesskey.c:1.15
--- less/lesskey.c:1.1.1.12	Sun Dec  1 05:41:09 1996
+++ less/lesskey.c	Sun Jan 12 18:16:13 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994,1995,1996  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -161,6 +164,9 @@
 	"undo-hilite",		A_UNDO_SEARCH,
 	"version",		A_VERSION,
 	"visual",		A_VISUAL,
+#if JAPANESE
+	"rotate-right",		A_ROT_RCODESET,
+#endif
 	NULL,			0
 };
 
Index: less/lesskey.nro
diff -u less/lesskey.nro:1.1.1.9 less/lesskey.nro:1.12
--- less/lesskey.nro:1.1.1.9	Sun Dec  1 05:41:16 1996
+++ less/lesskey.nro	Sun Jan 12 18:16:14 1997
@@ -177,6 +177,7 @@
 	v		visual 
 	!		shell 
 	+		firstcmd 
+	@		rotate-right 
 	H		help 
 	h		help 
 	V		version 
@@ -297,3 +298,7 @@
 Copyright (c) 1984,1985,1989,1994,1995  Mark Nudelman
 .br
 Comments to: marknu@netcom.com
+.br
+Copyright (c) 1994,1995,1996,1997  Kazushi (Jam) Marukawa, Japanized routines only
+.br
+Comments to: jam@poboxes.com
Index: less/line.c
diff -u less/line.c:1.1.1.8 less/line.c:1.68
--- less/line.c:1.1.1.8	Sat Sep 14 00:35:15 1996
+++ less/line.c	Sat Jan 25 01:17:49 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994,1995,1996  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -40,6 +43,8 @@
 public int cshift;		/* Current left-shift of output line buffer */
 public int hshift;		/* Desired left-shift of output line buffer */
 
+static CHARSET charset[LINEBUF_SIZE];
+				/* Extension of linebuf to hold character set */
 static char attr[LINEBUF_SIZE];	/* Extension of linebuf to hold attributes */
 static int curr;		/* Index into linebuf */
 static int column;		/* Printable length, accounting for
@@ -49,7 +54,9 @@
 static char pendc;
 static POSITION pendpos;
 
+static int pwidth();
 static int do_append();
+static int real_do_append();
 
 extern int bs_mode;
 extern int tabstop;
@@ -63,12 +70,14 @@
 extern int bl_s_width, bl_e_width;
 extern int so_s_width, so_e_width;
 extern int sc_width, sc_height;
+extern IFILE curr_ifile;
 
 /*
  * Rewind the line buffer.
  */
 	public void
-prewind()
+prewind(pos)
+	POSITION pos;
 {
 	curr = 0;
 	column = 0;
@@ -76,6 +85,9 @@
 	overstrike = 0;
 	is_null_line = 0;
 	pendc = '\0';
+#if ISO
+	prewind_multi(get_mulbuf(curr_ifile), pos);
+#endif
 }
 
 /*
@@ -108,7 +120,10 @@
 	n = strlen(&linebuf[curr]);
 	column += n;
 	for (i = 0;  i < n;  i++)
-		attr[curr++] = 0;
+	{
+		charset[curr] = ASCII;
+		attr[curr++] = AT_NORMAL;
+	}
 
 	/*
 	 * Append enough spaces to bring us to the next tab stop.
@@ -120,6 +135,7 @@
 	do
 	{
 		linebuf[curr] = ' ';
+		charset[curr] = ASCII;
 		attr[curr++] = AT_NORMAL;
 		column++;
 	} while (((column + cshift) % tabstop) != 0);
@@ -134,20 +150,48 @@
 	int shift;
 {
 	int i;
+	int j;
+	int exact_shift;		/* exact columns to shift */
+	int exact_length;	/* exact bytes to shift */
 
 	if (shift > column)
 		shift = column;
 	if (shift > curr)
 		shift = curr;
 
-	for (i = 0;  i < curr - shift;  i++)
+	/*
+	 * Calculate exact bytes to shift.
+	 */
+	exact_shift = 0;
+	exact_length = 0;
+	for (j = 0; j < curr && exact_shift < shift; j++)
 	{
-		linebuf[i] = linebuf[i + shift];
-		attr[i] = attr[i + shift];
+		/*
+		 * Use pwidth to compute exact columns.
+		 */
+		exact_shift += pwidth(linebuf[j], charset[j], attr[j]);
+		exact_length++;
+	}
+	while (j < curr && pwidth(linebuf[j], charset[j], attr[j]) == 0)
+	{
+		/*
+		 * Multi bytes character has 0 column information,
+		 * thus we have to skip them.
+		 */
+		exact_length++;
+		j++;
 	}
-	column -= shift;
-	curr -= shift;
-	cshift += shift;
+
+	for (i = 0;  i < curr - exact_length;  i++)
+	{
+		linebuf[i] = linebuf[i + exact_length];
+		charset[i] = charset[i + exact_length];
+		attr[i] = attr[i + exact_length];
+	}
+
+	column -= exact_shift;
+	curr -= exact_length;
+	cshift += exact_shift;
 }
 
 /*
@@ -193,8 +237,9 @@
  * attribute sequence to be inserted, so this must be taken into account.
  */
 	static int
-pwidth(c, a)
+pwidth(c, cs, a)
 	int c;
+	int cs;
 	int a;
 {
 	register int w;
@@ -217,7 +262,11 @@
 	 * Other characters take one space,
 	 * plus the width of any attribute enter/exit sequence.
 	 */
+#if ISO
+	w = mwidth(c, cs);
+#else
 	w = 1;
+#endif
 	if (curr > 0 && attr[curr-1] != a)
 		w += attr_ewidth(attr[curr-1]);
 	if (a && (curr == 0 || attr[curr-1] != a))
@@ -231,16 +280,24 @@
 	static void
 backc()
 {
-	curr--;
-	column -= pwidth(linebuf[curr], attr[curr]);
+	/* remove garbage in the buffer. */
+	if (CSISREST(charset[curr]))
+		charset[curr] = 0;
+	/* delete the previous character. */
+	do
+	{
+		curr--;
+		column -= pwidth(linebuf[curr], charset[curr], attr[curr]);
+	} while (curr > 0 && CSISREST(charset[curr]));
 }
 
 /*
  * Append a character and attribute to the line buffer.
  */
 	static int
-storec(c, a, pos)
+storec(c, cs, a, pos)
 	int c;
+	int cs;
 	int a;
 	POSITION pos;
 {
@@ -253,8 +310,28 @@
 		 * Override the attribute passed in.
 		 */
 		a = AT_STANDOUT;
+#if ISO
+	/*
+	 * All data of multi bytes character has same position.
+	 * However search mark data position and not character position.
+	 * Thus we must check all data position of each character.
+	 */
+	else if (CSISREST(cs))
+	{
+		register int i;
+		for (i = 1; CSISREST(charset[curr - i]); i++)
+			;
+		if (is_hilited(pos - i, pos, 0))
+		{
+			for (i = curr - 1; CSISREST(charset[i]); --i)
+				attr[i] = AT_STANDOUT;
+			attr[i] = AT_STANDOUT;
+			a = AT_STANDOUT;
+		}
+	}
 #endif
-	w = pwidth(c, a);
+#endif
+	w = pwidth(c, cs, a);
 	if (ctldisp > 0 && column + w + attr_ewidth(a) > sc_width)
 		/*
 		 * Won't fit on screen.
@@ -301,6 +378,7 @@
 	/* End of magic cookie handling. */
 
 	linebuf[curr] = c;
+	charset[curr] = cs;
 	attr[curr] = a;
 	column += w;
 	return (0);
@@ -358,15 +436,55 @@
 	int c;
 	POSITION pos;
 {
+#if ISO
+	char *cbuf;
+	CHARSET *csbuf;
+	int i, j;
+
+	buffering_multi(get_mulbuf(curr_ifile), c, &cbuf, &csbuf, &i);
+	j = i;
+	while (--i >= 0)
+	{
+		if (real_do_append(*cbuf++, *csbuf++, pos))
+		{
+			set_bufbytes(get_mulbuf(curr_ifile),
+				     get_bufbytes(get_mulbuf(curr_ifile)) -
+				     (j - (i + 1)));
+			return (1);
+		}
+	}
+	return (0);
+#else
+	return (real_do_append(c, ASCII, pos));
+#endif
+}
+
+	static int
+real_do_append(c, cs, pos)
+	register int c;
+	register CHARSET cs;
+	POSITION pos;
+{
 	register char *s;
 	register int a;
 
-#define	STOREC(c,a) \
-	if (storec((c),(a),pos)) return (1); else curr++
+#define	STOREC(c,cs,a) \
+	if (storec((c),(cs),(a),pos)) return (1); else curr++
 
+	if (CSISWRONG(cs))
+		goto do_control_char;
 	if (overstrike)
 	{
 		/*
+		 * Check about multi '\b' for multi bytes character.
+		 */
+		if (c == '\b')
+			if (linebuf[curr] == '_' && ISASCII(charset[curr]))
+				goto do_bs_char; /* do backc on underline */
+			else
+				return (0);		/* ignore it */
+
+		/*
 		 * Overstrike the character at the current position
 		 * in the line buffer.  This will cause either 
 		 * underline (if a "_" is overstruck), 
@@ -374,28 +492,37 @@
 		 * or just deletion of the character in the buffer.
 		 */
 		overstrike = 0;
-		if ((char)c == linebuf[curr])
-			STOREC(linebuf[curr], AT_BOLD);
-		else if (c == '_')
-			STOREC(linebuf[curr], AT_UNDERLINE);
-		else if (linebuf[curr] == '_')
-			STOREC(c, AT_UNDERLINE);
-		else if (control_char(c))
+		if (ISASCII(cs) && control_char(c))
 			goto do_control_char;
+		if ((char)c == linebuf[curr] && charset[curr] == cs)
+			STOREC(c, cs, AT_BOLD);
+		else if (c == '_' && ISASCII(cs))
+		{
+			STOREC(linebuf[curr], charset[curr], AT_UNDERLINE);
+#if ISO
+			while (CSISREST(charset[curr]))
+				STOREC(linebuf[curr], charset[curr],
+				       AT_UNDERLINE);
+#endif
+		} else if (linebuf[curr] == '_' && ISASCII(charset[curr]))
+			STOREC(c, cs, AT_UNDERLINE);
 		else
-			STOREC(c, AT_NORMAL);
+			STOREC(c, cs, AT_NORMAL);
 	} else if (c == '\b')
 	{
+	do_bs_char:
 		switch (bs_mode)
 		{
 		case BS_NORMAL:
-			STOREC(c, AT_NORMAL);
+			STOREC(c, cs, AT_NORMAL);
 			break;
 		case BS_CONTROL:
 			goto do_control_char;
 		case BS_SPECIAL:
 			if (curr == 0)
-				break;
+				goto do_control_char;
+			if (CSISWRONG(charset[curr - 1]))
+				goto do_control_char;
 			backc();
 			overstrike = 1;
 			break;
@@ -415,11 +542,11 @@
 		case BS_SPECIAL:
 			do
 			{
-				STOREC(' ', AT_NORMAL);
+				STOREC(' ', ASCII, AT_NORMAL);
 			} while (((column + cshift) % tabstop) != 0);
 			break;
 		}
-	} else if (control_char(c))
+	} else if (ISASCII(cs) && control_char(c))
 	{
 	do_control_char:
 		if (ctldisp == 0)
@@ -427,13 +554,14 @@
 			/*
 			 * Output as a normal character.
 			 */
-			STOREC(c, AT_NORMAL);
+			STOREC(c, cs, AT_NORMAL);
 		} else 
 		{
 			/*
 			 * Convert to printable representation.
 			 */
-			s = prchar(c);  
+			s = prchar(c, cs);  
+		binout:
 			a = binattr;
 
 			/*
@@ -445,11 +573,16 @@
 				return (1);
 
 			for ( ;  *s != 0;  s++)
-				STOREC(*s, a);
+				STOREC(*s, WRONG_CHAR | ASCII, a);
 		}
+#if ISO
+	} else if (CSISREST(cs))
+	{
+		STOREC(c, cs, attr[curr - 1]);
+#endif
 	} else
 	{
-		STOREC(c, AT_NORMAL);
+		STOREC(c, cs, AT_NORMAL);
 	}
 
 	return (0);
@@ -459,9 +592,17 @@
  * Terminate the line in the line buffer.
  */
 	public void
-pdone(endline)
+pdone(endline, pos)
 	int endline;
+	POSITION pos;
 {
+#if ISO
+	/*
+	 * Check and flush some buffering characters.
+	 */
+	(void) do_append(-1, pos);
+#endif
+
 	if (pendc && (pendc != '\r' || !endline))
 		/*
 		 * If we had a pending character, put it in the buffer.
@@ -483,11 +624,16 @@
 	if (column < sc_width || !auto_wrap || ignaw || ctldisp == 0)
 	{
 		linebuf[curr] = '\n';
+		charset[curr] = ASCII;
 		attr[curr] = AT_NORMAL;
 		curr++;
 	}
 	linebuf[curr] = '\0';
+	charset[curr] = ASCII;
 	attr[curr] = AT_NORMAL;
+#if ISO
+	pdone_multi(get_mulbuf(curr_ifile), pos);
+#endif
 }
 
 /*
@@ -496,8 +642,9 @@
  * and the character attribute in *ap.
  */
 	public int
-gline(i, ap)
+gline(i, csp, ap)
 	register int i;
+	register int *csp;
 	register int *ap;
 {
 	char *s;
@@ -508,11 +655,13 @@
 		 * If there is no current line, we pretend the line is
 		 * either "~" or "", depending on the "twiddle" flag.
 		 */
+		*csp = ASCII;
 		*ap = AT_NORMAL;
 		s = (twiddle) ? "~\n" : "\n";
 		return (s[i]);
 	}
 
+	*csp = charset[i];
 	*ap = attr[i];
 	return (linebuf[i] & 0377);
 }
